searchNodes=[{"doc":"Downloads and installs the latest Timezone GeoJSON data","ref":"Mix.Tasks.TzWorld.Update.html","title":"Mix.Tasks.TzWorld.Update","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1.","ref":"Mix.Tasks.TzWorld.Update.html#run/1","title":"Mix.Tasks.TzWorld.Update.run/1","type":"function"},{"doc":"Resolve a timezone name from coordinates.","ref":"TzWorld.html","title":"TzWorld","type":"module"},{"doc":"Returns all timezone name found for the given coordinates specified as either a Geo.Point, a Geo.PointZ or a tuple {lng, lat} Arguments point is a Geo.Point.t() a Geo.PointZ.t() or a tuple {lng, lat} backend is any backend access module. Returns {:ok, timezone} or {:error, :time_zone_not_found} Notes Note that the point is always expressed as lng followed by lat. Examples iex&gt; TzWorld.all_timezones_at(%Geo.Point{coordinates: {3.2, 45.32}}) {:ok, [&quot;Europe/Paris&quot;]} iex&gt; TzWorld.all_timezones_at({3.2, 45.32}) {:ok, [&quot;Europe/Paris&quot;]} iex&gt; TzWorld.all_timezones_at({0.0, 0.0}) {:ok, []} The algorithm starts by filtering out timezones whose bounding box does not contain the given point. Once filtered, all timezones which contains the given point is returned, or an error tuple if none of the timezones match. In rare cases, typically due to territorial disputes, one or more timezones may apply to a given location. This function returns all time zones that match.","ref":"TzWorld.html#all_timezones_at/2","title":"TzWorld.all_timezones_at/2","type":"function"},{"doc":"Returns the OTP app name of :tz_world","ref":"TzWorld.html#app_name/0","title":"TzWorld.app_name/0","type":"function"},{"doc":"","ref":"TzWorld.html#fetch_backend/0","title":"TzWorld.fetch_backend/0","type":"function"},{"doc":"Reload the timezone geometry data. This allows for the data to be reloaded, typically with a new release, without restarting the application.","ref":"TzWorld.html#reload_timezone_data/0","title":"TzWorld.reload_timezone_data/0","type":"function"},{"doc":"Returns the first timezone name found for the given coordinates specified as either a Geo.Point, a Geo.PointZ or a tuple {lng, lat} Arguments point is a Geo.Point.t() a Geo.PointZ.t() or a tuple {lng, lat} backend is any backend access module. Returns {:ok, timezone} or {:error, :time_zone_not_found} Notes Note that the point is always expressed as lng followed by lat. Examples iex&gt; TzWorld.timezone_at(%Geo.Point{coordinates: {3.2, 45.32}}) {:ok, &quot;Europe/Paris&quot;} iex&gt; TzWorld.timezone_at({3.2, 45.32}) {:ok, &quot;Europe/Paris&quot;} iex&gt; TzWorld.timezone_at({0.0, 0.0}) {:error, :time_zone_not_found} The algorithm starts by filtering out timezones whose bounding box does not contain the given point. Once filtered, the first timezone which contains the given point is returned, or an error tuple if none of the timezones match. In rare cases, typically due to territorial disputes, one or more timezones may apply to a given location. This function returns the first time zone that matches.","ref":"TzWorld.html#timezone_at/2","title":"TzWorld.timezone_at/2","type":"function"},{"doc":"Returns the installed version of time zone data Example iex&gt; TzWorld.version {:ok, &quot;2020a&quot;}","ref":"TzWorld.html#version/0","title":"TzWorld.version/0","type":"function"},{"doc":"","ref":"TzWorld.html#t:backend/0","title":"TzWorld.backend/0","type":"type"},{"doc":"Defines the callbacks for the TzWorld.Backend behaviour","ref":"TzWorld.Backend.html","title":"TzWorld.Backend","type":"behaviour"},{"doc":"Returns all timezones at a specified point","ref":"TzWorld.Backend.html#c:all_timezones_at/1","title":"TzWorld.Backend.all_timezones_at/1","type":"callback"},{"doc":"Reloads the (potentially updated) timezone data","ref":"TzWorld.Backend.html#c:reload_timezone_data/0","title":"TzWorld.Backend.reload_timezone_data/0","type":"callback"},{"doc":"Returns the time zone at a specified point","ref":"TzWorld.Backend.html#c:timezone_at/1","title":"TzWorld.Backend.timezone_at/1","type":"callback"},{"doc":"A point","ref":"TzWorld.Backend.html#t:geo/0","title":"TzWorld.Backend.geo/0","type":"type"},{"doc":"Latitude in degrees","ref":"TzWorld.Backend.html#t:lat/0","title":"TzWorld.Backend.lat/0","type":"type"},{"doc":"Longitude in degrees","ref":"TzWorld.Backend.html#t:lng/0","title":"TzWorld.Backend.lng/0","type":"type"},{"doc":"","ref":"TzWorld.Backend.Memory.html","title":"TzWorld.Backend.Memory","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"TzWorld.Backend.Memory.html#child_spec/1","title":"TzWorld.Backend.Memory.child_spec/1","type":"function"},{"doc":"Function to support downloading the latest timezones geo JSON data","ref":"TzWorld.Downloader.html","title":"TzWorld.Downloader","type":"module"},{"doc":"","ref":"TzWorld.Downloader.html#certificate_store/0","title":"TzWorld.Downloader.certificate_store/0","type":"function"},{"doc":"Returns the current installed timezones geo JSON data.","ref":"TzWorld.Downloader.html#current_release/0","title":"TzWorld.Downloader.current_release/0","type":"function"},{"doc":"","ref":"TzWorld.Downloader.html#get_and_load_latest_release/2","title":"TzWorld.Downloader.get_and_load_latest_release/2","type":"function"},{"doc":"","ref":"TzWorld.Downloader.html#get_latest_release/2","title":"TzWorld.Downloader.get_latest_release/2","type":"function"},{"doc":"Return the {release_number, download_url} of the latest timezones geo JSON data","ref":"TzWorld.Downloader.html#latest_release/0","title":"TzWorld.Downloader.latest_release/0","type":"function"},{"doc":"Updates the timezone geo JSON data if there is a more recent release.","ref":"TzWorld.Downloader.html#update_release/0","title":"TzWorld.Downloader.update_release/0","type":"function"},{"doc":"TzWorld Resolve timezones from a location using data from the timezone-boundary-builder project.","ref":"readme.html","title":"TzWorld","type":"extras"},{"doc":"Add tz_world to your list of dependencies in mix.exs: def deps do [ {:tz_world, &quot;~&gt; 0.4.0&quot;} ] end After adding TzWorld as a dependency, run mix deps.get to install it. Then run mix tz_world.update to install the timezone data. NOTE No data is installed with the package and until the data is installed with mix tz_world.update all calls to TzWorld.timezone_at/1 will return {:error, :time_zone_not_found}. Configuration There is no mandatory configuration required however two options may be configured in config.exs: config :tz_world, data_dir: &quot;geodata/directory&quot;, # The default is the `priv` directory of `:tz_world` cacertfile: &quot;path/to/ca_trust_store&quot; # The defaul is either the trust store included in the # libraries [`CAStore`](https://hexdocs.pm/castore/0.1.5/CAStore.html) or `certifi` or the platform # trust store.","ref":"readme.html#installation","title":"TzWorld - Installation","type":"extras"},{"doc":"TzWorld provides alternative strategies for managing access to the backend data. Each backend is implemented as a GenServer that needs to be either manually started with BackendModule.start_link/1 or preferably added to your application&#39;s supervision tree. The recommended backend is TzWorld.Backend.EtsWithIndexCache. For example: defmodule MyApp.Application do @moduledoc false use Application def start(_type, _args) do children = [ ... TzWorld.Backend.DetsWithIndexCache ] opts = [strategy: :one_for_one, name: MyApp.Supervisor] Supervisor.start_link(children, opts) end end The following backends are available: TzWorld.Backend.Memory which retains all data in memory for fast (but not fastest) performance at the expense of using approximately 1Gb of memory TzWorld.Backend.Dets which uses Erlang&#39;s :dets data store. This uses negligible memory at the expense of slow access times (approximaltey 500ms in testing) TzWorld.Backend.DetsWithIndexCache which balances memory usage and performance. This backend is recommended in most situations since its performance is similar to TzWorld.Backend.Memory (about 5% slower in testing) and uses about 25Mb of memory TzWorld.Backend.Ets which uses :ets for storage. With the default settings of :compressed for the :ets table its memory consumption is about 512Mb but with access that is over 20 times slower than TzWorld.Backend.DetsWithIndexCache TzWorld.Backend.EtsWithIndexCache which uses :ets for storage with an additional in-memory cache of the bounding boxes. This still uses about 512Mb but is faster than any of the other backends by about 40%","ref":"readme.html#backend-selection","title":"TzWorld - Backend selection","type":"extras"},{"doc":"Installing tz_world from source or from hex does not include the timezones geo JSON data. The data is requried and to install or update it run: mix tz_world.update This task will download, transform, zip and store the timezones geo data. Depending on internet and computer speed this may take a few minutes. Updating the Timezone data From time-to-time the timezones geo JSON data is updated in the upstream project. The mix task mix tz_world.update will update the data if it is available. This task can be run at any time, it will detect when new data is available and only download it when a new release is available. A running application can also be instructed to reload the data by executing TzWorld.reload_timezone_data.","ref":"readme.html#installing-the-timezones-geo-json-data","title":"TzWorld - Installing the Timezones Geo JSON data","type":"extras"},{"doc":"The primary API is TzWorld.timezone_at. It takes either a Geo.Point struct or a longitude and latitude in degrees. Note the parameter order: longitude, latitude. It also takes and optional second parameter, backend, which must be one of the configured and running backend modules. By default timezone_at/2 will detect a running backend and will raise an exception if no running backend is found. iex&gt; TzWorld.timezone_at(%Geo.Point{coordinates: {3.2, 45.32}}) {:ok, &quot;Europe/Paris&quot;} iex&gt; TzWorld.timezone_at({3.2, 45.32}) {:ok, &quot;Europe/Paris&quot;} iex&gt; TzWorld.timezone_at(%Geo.PointZ{coordinates: {-74.006, 40.7128, 0.0}}) {:ok, &quot;America/New_York&quot;} iex&gt; TzWorld.timezone_at(%Geo.Point{coordinates: {1.3, 65.62}}) {:error, :time_zone_not_found}","ref":"readme.html#usage","title":"TzWorld - Usage","type":"extras"},{"doc":"MIT License Copyright (c) 2017 kimlai Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"LICENSE","type":"extras"},{"doc":"Changelog for Tz_World v0.5.0 This is the changelog for Tz_World v0.5.0 released on May 23rd, 2020. For older changelogs please consult the release tag on GitHub Bug Fixes Move compile time configuration of the data directory to runtime and remove hard-coded default path Start :inets and :ssl applications in the downloader mix task Add certificate verification when downloading updates to the geo data Enhancements Document the :data_dir and :cacertfile configuration options it the README.md file The backends :dets and :dets_with_index_cache now open the :dets file as access: :read which prevents errors if the file is abnormally closed. Changelog for Tz_World v0.4.0 This is the changelog for Tz_World v0.4.0 released on May 12th, 2020. For older changelogs please consult the release tag on GitHub Adds configurable backends. Each backend is a GenServer that must be added to an applications supervision tree or started manually. Breaking change When specifying a lng, lat to TzWorld.timezone_at/2 the coordinates must be wrapped in a tuple. For example TzWorld.timezone_at({3.2, 45.32}) making it consistent with the Geo.Point and Geo.PointZ strategies. Configurable backends TzWorld.Backend.Memory which retains all data in memory for fast (but not fastest) performance at the expense of using approximately 1Gb of memory TzWorld.Backend.Dets which uses Erlang&#39;s :dets data store. This uses negligible memory at the expense of slow access times (approximaltey 500ms in testing) TzWorld.Backend.DetsWithIndexCache which balances memory usage and performance. This backend is recommended in most situations since its performance is similar to TzWorld.Backend.Memory (about 5% slower in testing) and uses about 25Mb of memory TzWorld.Backend.Ets which uses :ets for storage. With the default settings of :compressed for the :ets table its memory consumption is about 512Mb but with access that is over 20 times slower than TzWorld.Backend.DetsWithIndexCache TzWorld.Backend.EtsWithIndexCache which uses :ets for storage with an additional in-memory cache of the bounding boxes. This still uses about 512Mb but is faster than any of the other backends by about 40% Enhancements Add TzWorld.all_timezones_at/2 to return all timezones for a given location. In rare cases, usually disputed territory, multiple timezones may be declared for overlapping regions. TzWorld.all_timezones_at/2 returns a (potentially empty) list of all time zones known for a given point. Futher testing of this function is required and will be completed before version 1.0. Changelog for Tz_World v0.3.0 This is the changelog for Tz_World v0.3.0 released on December 4th, 2019. For older changelogs please consult the release tag on GitHub Breaking Changes Changes the error return from {:error, :timezone_not_found} to {:error, :time_zone_not_found} since both Elixir and Tzdata use time_zone. Enhancements Allows both %Geo.Point{} and %Geo.PointZ{} as parameters to TzWorld.timezone_at/1 Changelog for Tz_World v0.2.0 This is the changelog for Tz_World v0.2.0 released on November 28th, 2019. For older changelogs please consult the release tag on GitHub Breaking Changes Requires OTP 21 and Elixir 1.6 or later due to the use of GenServer&#39;s handle_continue/2 timezone_at/1 returns tagged tuples {:ok, result} or {:error, reason}. There can be at least two reasons for an error: no data file is available or no timezone is found. These return {:error, :enoent} and {:error, :timezone_not_found} respectively The timezone geojson data is no longer included in the package. Run mix tz_world.update to install or update it. No longer uses Ecto or PostGIS for calculations. Enhancements Updated to latest shape data. Takes the geo JSON shape data directly from timezone-boundary-builder releases Conforms TzWorker to the modern child_spec/1 including using handle_continue/2 to load the data file if it exists. Updated dependencies including geo to allow 1.x, 2.x or 3.x Added Jason as an optional dependency to facilitate decoding the GeoJSON from timezone_boundary_builder The timezone geojson data is no longer included in the package. Its size isn&#39;t supported on hex and it bloats the repo too. A mix task tz_world.update downloads and processes the data. The function TzWorld.Downloader.update_release/0 can be called at any time to look for a new release, download it and load it into the running server with no downtime. timezone_at/1 supports simple lng, lat arguments as well as %Geo.Point{} structs Added CHANGELOG.md Added SRID to the GeoJSON Updated package and ran dialyzer Added a config option :data_dir specifies the location of the compressed etf. Default is ./priv Updated README, package and docs","ref":"changelog.html","title":"Changelog for Tz_World v0.5.0","type":"extras"}]